var $AdfUIUtils$$ = {$dumpHtmlDom$:function($target$$83$$, $targetName$$) {
  $AdfUIUtils$$.dump($target$$83$$, $targetName$$, {innerText:1, $outerText$:1, outerHTML:1, innerHTML:1});
}};
$goog$exportSymbol$$("AdfUIUtils.dumpHtmlDom", $AdfUIUtils$$.$dumpHtmlDom$);
$AdfUIUtils$$.dump = function $$AdfUIUtils$$$dump$($target$$84$$, $targetName$$1$$, $propCount$$1_suppressedProps$$) {
  var $propText$$ = "";
  if ($target$$84$$) {
    var $propNames$$1_targetType$$ = typeof $target$$84$$, $currPropNameIndex_isFunction$$1_propIndex$$ = "function" == $propNames$$1_targetType$$;
    if ("object" == $propNames$$1_targetType$$ || $currPropNameIndex_isFunction$$1_propIndex$$) {
      $currPropNameIndex_isFunction$$1_propIndex$$ ? $propText$$ = $propNames$$1_targetType$$ + ":" + $target$$84$$.valueOf() : $AdfCollections$$.isArray($target$$84$$) && ($propText$$ = "Array length\x3d" + $target$$84$$.length + " contents\x3d[" + $target$$84$$.valueOf() + "] ");
      if (!$targetName$$1$$) {
        try {
          $targetName$$1$$ = $target$$84$$.name;
        } catch ($e$$19$$) {
        }
      }
      $currPropNameIndex_isFunction$$1_propIndex$$ = 0;
      $propNames$$1_targetType$$ = [];
      try {
        for (var $currPropName$$1_propColumns$$ in $target$$84$$) {
          $propCount$$1_suppressedProps$$ && $propCount$$1_suppressedProps$$[$currPropName$$1_propColumns$$] || $currPropName$$1_propColumns$$.match(/DOM/) || ($propNames$$1_targetType$$[$currPropNameIndex_isFunction$$1_propIndex$$] = $currPropName$$1_propColumns$$, $currPropNameIndex_isFunction$$1_propIndex$$++);
        }
      } catch ($e$$20$$) {
        return "Unable to retrieve iterator on " + $targetName$$1$$ + ":" + $e$$20$$;
      }
      $propNames$$1_targetType$$.sort();
      $propCount$$1_suppressedProps$$ = $propNames$$1_targetType$$.length;
      $currPropName$$1_propColumns$$ = Math.ceil($propCount$$1_suppressedProps$$ / $AdfUIUtils$$.$_MAX_ALERT_ROWS$);
      for ($currPropNameIndex_isFunction$$1_propIndex$$ = 0;$currPropNameIndex_isFunction$$1_propIndex$$ < $propCount$$1_suppressedProps$$;$currPropNameIndex_isFunction$$1_propIndex$$++) {
        var $currPropText$$ = "", $currPropText$$ = $AdfUIUtils$$.$_getKeyValueString$($target$$84$$, $propNames$$1_targetType$$[$currPropNameIndex_isFunction$$1_propIndex$$]), $currPropText$$ = $currPropText$$ + $AdfUIUtils$$.$getTabbedSpacer$($currPropNameIndex_isFunction$$1_propIndex$$, $currPropName$$1_propColumns$$), $propText$$ = $propText$$ + $currPropText$$
      }
      $targetName$$1$$ || ($targetName$$1$$ = "" + $target$$84$$);
    } else {
      $propText$$ = $propNames$$1_targetType$$ + ":" + $target$$84$$.valueOf();
    }
  } else {
    $targetName$$1$$ || ($targetName$$1$$ = "(Undefined)");
  }
  "" == $propText$$ && ($propText$$ = "No properties");
  alert("Dump of " + $targetName$$1$$ + ":\n" + $propText$$);
};
$goog$exportSymbol$$("AdfUIUtils.dump", $AdfUIUtils$$.dump);
$AdfUIUtils$$.$_getKeyValueString$ = function $$AdfUIUtils$$$$_getKeyValueString$$($target$$85$$, $key$$34$$) {
  var $value$$109$$;
  try {
    $value$$109$$ = $target$$85$$[$key$$34$$];
  } catch ($e$$21$$) {
    $value$$109$$ = $e$$21$$;
  }
  "function" == typeof $value$$109$$ && ($value$$109$$ = "[function]");
  return $key$$34$$ + ":" + $value$$109$$;
};
$AdfUIUtils$$.$getTabbedSpacer$ = function $$AdfUIUtils$$$$getTabbedSpacer$$($propertyIndex$$, $columns$$) {
  $columns$$ || ($columns$$ = 3);
  return $AdfAgent$$.$AGENT$.$isGecko$ ? 0 == ($propertyIndex$$ + 1) % $columns$$ ? "\n" : "    " : "\t";
};
$goog$exportSymbol$$("AdfUIUtils.getTabbedSpacer", $AdfUIUtils$$.$getTabbedSpacer$);
$AdfUIUtils$$.$getSingleSpacer$ = function $$AdfUIUtils$$$$getSingleSpacer$$() {
  return " ";
};
$goog$exportSymbol$$("AdfUIUtils.getSingleSpacer", $AdfUIUtils$$.$getSingleSpacer$);
$AdfUIUtils$$.$getCommaSpacer$ = function $$AdfUIUtils$$$$getCommaSpacer$$() {
  return ",";
};
$goog$exportSymbol$$("AdfUIUtils.getCommaSpacer", $AdfUIUtils$$.$getCommaSpacer$);
$AdfUIUtils$$.$getPropertiesAsString$ = function $$AdfUIUtils$$$$getPropertiesAsString$$($target$$86$$, $spaceFunction$$, $showFunctions$$, $showConstants$$) {
  if (!$target$$86$$) {
    return "No target";
  }
  var $outString$$ = "";
  null == $showFunctions$$ && ($showFunctions$$ = !0);
  null == $showConstants$$ && ($showConstants$$ = !0);
  var $index$$57_targetType$$1$$ = typeof $target$$86$$, $currPropText$$1_isFunction$$2$$ = "function" == $index$$57_targetType$$1$$;
  if ("object" == $index$$57_targetType$$1$$ || $currPropText$$1_isFunction$$2$$) {
    $currPropText$$1_isFunction$$2$$ ? $outString$$ = $index$$57_targetType$$1$$ + ":" + $target$$86$$.valueOf() : $AdfCollections$$.isArray($target$$86$$) && ($outString$$ = "Array length\x3d" + $target$$86$$.length + " contents\x3d[" + $target$$86$$.valueOf() + "] ");
    void 0 == $spaceFunction$$ && ($spaceFunction$$ = $AdfUIUtils$$.$getTabbedSpacer$);
    var $index$$57_targetType$$1$$ = 0, $currPropName$$2$$;
    for ($currPropName$$2$$ in $target$$86$$) {
      if ($currPropText$$1_isFunction$$2$$ = "", $showConstants$$ || $currPropName$$2$$ != $currPropName$$2$$.toUpperCase()) {
        try {
          var $value$$110$$ = $target$$86$$[$currPropName$$2$$];
          if ("function" == typeof $value$$110$$) {
            if (!$showFunctions$$) {
              continue;
            }
            $value$$110$$ = "[function]";
          }
          $currPropText$$1_isFunction$$2$$ = $currPropName$$2$$ + ":" + $value$$110$$;
          $spaceFunction$$ && ($currPropText$$1_isFunction$$2$$ += $spaceFunction$$($index$$57_targetType$$1$$++));
        } catch ($e$$22$$) {
        }
        $outString$$ += $currPropText$$1_isFunction$$2$$;
      }
    }
    $outString$$.length || ($outString$$ = "Unknown:" + $target$$86$$.valueOf());
  } else {
    $outString$$ = $index$$57_targetType$$1$$ + ":" + $target$$86$$.valueOf();
  }
  return $outString$$;
};
$goog$exportSymbol$$("AdfUIUtils.getPropertiesAsString", $AdfUIUtils$$.$getPropertiesAsString$);
$AdfUIUtils$$.$compareArrays$ = function $$AdfUIUtils$$$$compareArrays$$($array1$$, $array2$$) {
  $AdfAssert$$.assert(Array.prototype.isPrototypeOf($array1$$));
  $AdfAssert$$.assert(Array.prototype.isPrototypeOf($array2$$));
  if ($array1$$.length == $array2$$.length) {
    for (var $index$$58$$ = 0, $len$$4$$ = $array1$$.length;$index$$58$$ < $len$$4$$;$index$$58$$++) {
      if (!$AdfUIUtils$$.$compareValues$($array1$$[$index$$58$$], $array2$$[$index$$58$$])) {
        return !1;
      }
    }
    return !0;
  }
  return !1;
};
$goog$exportSymbol$$("AdfUIUtils.compareArrays", $AdfUIUtils$$.$compareArrays$);
$AdfUIUtils$$.$compareObjects$ = function $$AdfUIUtils$$$$compareObjects$$($object1$$, $object2$$) {
  $AdfAssert$$.assert(Object.prototype.isPrototypeOf($object1$$));
  $AdfAssert$$.assert(Object.prototype.isPrototypeOf($object2$$));
  var $equalsFunc_value1$$9$$ = $object1$$.equals;
  if ($equalsFunc_value1$$9$$ && "function" == typeof $equalsFunc_value1$$9$$) {
    return $equalsFunc_value1$$9$$.call($object1$$, $object2$$);
  }
  for (var $index$$59$$ in $object1$$) {
    var $equalsFunc_value1$$9$$ = $object1$$[$index$$59$$], $value2$$8$$ = $object2$$[$index$$59$$];
    if (!$AdfUIUtils$$.$compareValues$($equalsFunc_value1$$9$$, $value2$$8$$)) {
      return !1;
    }
  }
  for ($index$$59$$ in $object2$$) {
    if ($equalsFunc_value1$$9$$ = $object1$$[$index$$59$$], $value2$$8$$ = $object2$$[$index$$59$$], !$AdfUIUtils$$.$compareValues$($value2$$8$$, $equalsFunc_value1$$9$$)) {
      return !1;
    }
  }
  return !0;
};
$goog$exportSymbol$$("AdfUIUtils.compareObjects", $AdfUIUtils$$.$compareObjects$);
$AdfUIUtils$$.$compareValues$ = function $$AdfUIUtils$$$$compareValues$$($value1$$10$$, $value2$$9$$) {
  var $equal$$1$$ = $value1$$10$$ === $value2$$9$$;
  $equal$$1$$ || null == $value1$$10$$ || null == $value2$$9$$ || (Array.prototype.isPrototypeOf($value1$$10$$) && Array.prototype.isPrototypeOf($value2$$9$$) ? $equal$$1$$ = $AdfUIUtils$$.$compareArrays$($value1$$10$$, $value2$$9$$) : $AdfObject$$.prototype.isPrototypeOf($value1$$10$$) && $AdfObject$$.prototype.isPrototypeOf($value2$$9$$) ? $equal$$1$$ = $value1$$10$$.$equals$($value2$$9$$) : Object.prototype.isPrototypeOf($value1$$10$$) && Object.prototype.isPrototypeOf($value2$$9$$) && ($equal$$1$$ = 
  $AdfUIUtils$$.$compareObjects$($value1$$10$$, $value2$$9$$)));
  return $equal$$1$$;
};
$goog$exportSymbol$$("AdfUIUtils.compareValues", $AdfUIUtils$$.$compareValues$);
$AdfUIUtils$$.trim = function $$AdfUIUtils$$$trim$($data$$37$$) {
  return $AdfStrings$$.trim($data$$37$$);
};
$goog$exportSymbol$$("AdfUIUtils.trim", $AdfUIUtils$$.trim);
$AdfUIUtils$$.$trimLeading$ = function $$AdfUIUtils$$$$trimLeading$$($data$$38$$) {
  return $AdfStrings$$.$trimLeading$($data$$38$$);
};
$goog$exportSymbol$$("AdfUIUtils.trimLeading", $AdfUIUtils$$.$trimLeading$);
$AdfUIUtils$$.$trimTrailing$ = function $$AdfUIUtils$$$$trimTrailing$$($data$$39$$) {
  return $AdfStrings$$.$trimTrailing$($data$$39$$);
};
$goog$exportSymbol$$("AdfUIUtils.trimTrailing", $AdfUIUtils$$.$trimTrailing$);
$AdfUIUtils$$.$_MAX_ALERT_ROWS$ = 28;
